/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.person.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="PERSONENDATEN_DATEI_EXPORT.Personendaten",
     query="SELECT obj FROM PersonendatenDateiExport obj WHERE obj.personendaten = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "PERSONENDATEN_DATEI_EXPORT")
// @javax.persistence.IdClass(PersonendatenDateiExportPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class PersonendatenDateiExport
extends AbstractPersonendatenDateiExport
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public PersonendatenDateiExport() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public PersonendatenDateiExport(PersonendatenDateiExport original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "personendaten_datei_export_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "PersonendatenDateiExport")
    @javax.persistence.TableGenerator(name = "PersonendatenDateiExport", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "PersonendatenDateiExport", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient PersonendatenDateiExportPK pkCache;

  @Override
  public PersonendatenDateiExportPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new PersonendatenDateiExportPK(getId());
    }

    return pkCache;
  }

  public static <E extends PersonendatenDateiExport> java.util.Map<PersonendatenDateiExportPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<PersonendatenDateiExportPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends PersonendatenDateiExport> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedBenutzerkennung = false;
          hasChangedDateiname = false;
          hasChangedDateiArt = false;
          hasChangedDokumentVorlageArt = false;
          hasChangedDokumentVorlageDateiname = false;
          hasChangedDokumentVorlageName = false;
          hasChangedErstellungszeitpunkt = false;
  
      hasChangedDatei = false;
        hasChangedPersonendaten = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = PersonendatenDateiExportConstants.BEMERKUNG_NULLABLE, length=PersonendatenDateiExportConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, PersonendatenDateiExportConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


      

       this.bemerkung = bemerkungInternal;

         }

        
      @javax.persistence.Column(name = "BENUTZERKENNUNG", nullable = PersonendatenDateiExportConstants.BENUTZERKENNUNG_NULLABLE, length=PersonendatenDateiExportConstants.BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String benutzerkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBenutzerkennung = false;

  public boolean hasChangedBenutzerkennung(){
    return hasChangedBenutzerkennung;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.BENUTZERKENNUNG
   */
    @Override   public  java.lang.String getBenutzerkennung() {
        return benutzerkennung;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.BENUTZERKENNUNG
   *
   * @param benutzerkennung
   */
  @Override   public void setBenutzerkennung( java.lang.String benutzerkennung) {

       resetTkCache();
                  
                          java.lang.String benutzerkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(benutzerkennung, PersonendatenDateiExportConstants.BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.benutzerkennung
      , benutzerkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBenutzerkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("benutzerkennung");
      }


      

       this.benutzerkennung = benutzerkennungInternal;

         }

        
      @javax.persistence.Column(name = "DATEINAME", nullable = PersonendatenDateiExportConstants.DATEINAME_NULLABLE, length=PersonendatenDateiExportConstants.DATEINAME_MAX_LENGTH)
        
  protected java.lang.String dateiname =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDateiname = false;

  public boolean hasChangedDateiname(){
    return hasChangedDateiname;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.DATEINAME
   */
    @Override   public  java.lang.String getDateiname() {
        return dateiname;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.DATEINAME
   *
   * @param dateiname
   */
  @Override   public void setDateiname( java.lang.String dateiname) {

       resetTkCache();
                  
                          java.lang.String dateinameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(dateiname, PersonendatenDateiExportConstants.DATEINAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dateiname
      , dateinameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDateiname |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dateiname");
      }


      

       this.dateiname = dateinameInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "DATEI_ART", nullable = PersonendatenDateiExportConstants.DATEI_ART_NULLABLE)
    
  protected de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDateiArt = false;

  public boolean hasChangedDateiArt(){
    return hasChangedDateiArt;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.DATEI_ART
   */
    @Override   public  de.ivu.elect.business.exchange.entity.DateiExportArt getDateiArt() {
        return dateiArt;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.DATEI_ART
   *
   * @param dateiArt
   */
  @Override   public void setDateiArt( de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt) {

       resetTkCache();
                  de.ivu.elect.business.exchange.entity.DateiExportArt dateiArtInternal = dateiArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dateiArt
      , dateiArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDateiArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dateiArt");
      }


      

       this.dateiArt = dateiArtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
  @javax.persistence.Column(name = "DOKUMENT_VORLAGE_ART", nullable = PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_ART_NULLABLE)
    
  protected de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDokumentVorlageArt = false;

  public boolean hasChangedDokumentVorlageArt(){
    return hasChangedDokumentVorlageArt;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_ART
   */
  @javax.annotation.Nullable   @Override   public  de.ivu.elect.business.dokumente.entity.DokumentVorlageArt getDokumentVorlageArt() {
        return dokumentVorlageArt;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_ART
   *
   * @param dokumentVorlageArt
   */
  @Override   public void setDokumentVorlageArt(@javax.annotation.Nullable  de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArt) {

       resetTkCache();
                  de.ivu.elect.business.dokumente.entity.DokumentVorlageArt dokumentVorlageArtInternal = dokumentVorlageArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dokumentVorlageArt
      , dokumentVorlageArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDokumentVorlageArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dokumentVorlageArt");
      }


      

       this.dokumentVorlageArt = dokumentVorlageArtInternal;

         }

        
  @javax.persistence.Column(name = "DOKUMENT_VORLAGE_DATEINAME", nullable = PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_DATEINAME_NULLABLE, length=PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_DATEINAME_MAX_LENGTH)
        
  protected java.lang.String dokumentVorlageDateiname =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDokumentVorlageDateiname = false;

  public boolean hasChangedDokumentVorlageDateiname(){
    return hasChangedDokumentVorlageDateiname;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_DATEINAME
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getDokumentVorlageDateiname() {
        return dokumentVorlageDateiname;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_DATEINAME
   *
   * @param dokumentVorlageDateiname
   */
  @Override   public void setDokumentVorlageDateiname(@javax.annotation.Nullable  java.lang.String dokumentVorlageDateiname) {

       resetTkCache();
                  
                          java.lang.String dokumentVorlageDateinameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(dokumentVorlageDateiname, PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_DATEINAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dokumentVorlageDateiname
      , dokumentVorlageDateinameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDokumentVorlageDateiname |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dokumentVorlageDateiname");
      }


      

       this.dokumentVorlageDateiname = dokumentVorlageDateinameInternal;

         }

        
  @javax.persistence.Column(name = "DOKUMENT_VORLAGE_NAME", nullable = PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_NAME_NULLABLE, length=PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_NAME_MAX_LENGTH)
        
  protected java.lang.String dokumentVorlageName =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDokumentVorlageName = false;

  public boolean hasChangedDokumentVorlageName(){
    return hasChangedDokumentVorlageName;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_NAME
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getDokumentVorlageName() {
        return dokumentVorlageName;
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.DOKUMENT_VORLAGE_NAME
   *
   * @param dokumentVorlageName
   */
  @Override   public void setDokumentVorlageName(@javax.annotation.Nullable  java.lang.String dokumentVorlageName) {

       resetTkCache();
                  
                          java.lang.String dokumentVorlageNameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(dokumentVorlageName, PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dokumentVorlageName
      , dokumentVorlageNameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDokumentVorlageName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dokumentVorlageName");
      }


      

       this.dokumentVorlageName = dokumentVorlageNameInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ERSTELLUNGSZEITPUNKT", nullable = PersonendatenDateiExportConstants.ERSTELLUNGSZEITPUNKT_NULLABLE, precision=PersonendatenDateiExportConstants.ERSTELLUNGSZEITPUNKT_PRECISION)
    
  protected java.util.Date erstellungszeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErstellungszeitpunkt = false;

  public boolean hasChangedErstellungszeitpunkt(){
    return hasChangedErstellungszeitpunkt;
  }
  
  /**
   * 
   *
   * getter for PERSONENDATEN_DATEI_EXPORT.ERSTELLUNGSZEITPUNKT
   */
    @Override   public  java.util.Date getErstellungszeitpunkt() {
              if (erstellungszeitpunkt == null){
            return null;
          } else {
                          return erstellungszeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for PERSONENDATEN_DATEI_EXPORT.ERSTELLUNGSZEITPUNKT
   *
   * @param erstellungszeitpunkt
   */
  @Override   public void setErstellungszeitpunkt( java.util.Date erstellungszeitpunkt) {

       resetTkCache();
                  java.util.Date erstellungszeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(erstellungszeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erstellungszeitpunkt
      , erstellungszeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErstellungszeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erstellungszeitpunkt");
      }


      

       this.erstellungszeitpunkt = erstellungszeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Datei
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "DATEI_ID", referencedColumnName="DATEI_ID"))
  protected de.ivu.elect.business.datei.entity.Datei datei;

  /**
   * 
   */
  @Override
  public void setDatei(@javax.annotation.Nullable  de.ivu.elect.business.datei.entity.Datei datei){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datei
    , datei);

    attributeChanged |= thisAttributChanged;

    hasChangedDatei |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("datei");
    }

    this.datei = datei;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.datei.entity.Datei getDatei(){
    return this.datei;
  }

  @javax.persistence.Transient
  protected boolean hasChangedDatei = false;

  public boolean hasChangedDatei(){
    return hasChangedDatei;
  }

  /**
   * Beziehung (unidirektional) zu Personendaten
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "PERSONENDATEN_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.person.entity.Personendaten personendaten;

  /**
   * 
   */
  @Override
  public void setPersonendaten( de.ivu.elect.business.person.entity.Personendaten personendaten){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personendaten
    , personendaten);

    attributeChanged |= thisAttributChanged;

    hasChangedPersonendaten |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("personendaten");
    }

    this.personendaten = personendaten;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.person.entity.Personendaten getPersonendaten(){
    return this.personendaten;
  }

  @javax.persistence.Transient
  protected boolean hasChangedPersonendaten = false;

  public boolean hasChangedPersonendaten(){
    return hasChangedPersonendaten;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("PersonendatenDateiExport:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(PersonendatenDateiExport other){
                             other.bemerkung = this.bemerkung;
                                other.benutzerkennung = this.benutzerkennung;
                                other.dateiname = this.dateiname;
                                other.dateiArt = this.dateiArt;
                                other.dokumentVorlageArt = this.dokumentVorlageArt;
                                other.dokumentVorlageDateiname = this.dokumentVorlageDateiname;
                                other.dokumentVorlageName = this.dokumentVorlageName;
                                other.erstellungszeitpunkt = this.erstellungszeitpunkt;
           
  other.setDatei(this.getDatei());
  other.setPersonendaten(this.getPersonendaten());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(PersonendatenDateiExport.class)){
        copyEntityAttributesUsingSetter((PersonendatenDateiExport) other.castTo(PersonendatenDateiExport.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von PersonendatenDateiExport: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(PersonendatenDateiExport other){
               other.setBemerkung(this.bemerkung);
                  other.setBenutzerkennung(this.benutzerkennung);
                  other.setDateiname(this.dateiname);
                  other.setDateiArt(this.dateiArt);
                  other.setDokumentVorlageArt(this.dokumentVorlageArt);
                  other.setDokumentVorlageDateiname(this.dokumentVorlageDateiname);
                  other.setDokumentVorlageName(this.dokumentVorlageName);
                  other.setErstellungszeitpunkt(this.erstellungszeitpunkt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(PersonendatenDateiExport other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedBenutzerkennung) {
        other.setBenutzerkennung(this.benutzerkennung);
      }
                             if (hasChangedDateiname) {
        other.setDateiname(this.dateiname);
      }
                             if (hasChangedDateiArt) {
        other.setDateiArt(this.dateiArt);
      }
                             if (hasChangedDokumentVorlageArt) {
        other.setDokumentVorlageArt(this.dokumentVorlageArt);
      }
                             if (hasChangedDokumentVorlageDateiname) {
        other.setDokumentVorlageDateiname(this.dokumentVorlageDateiname);
      }
                             if (hasChangedDokumentVorlageName) {
        other.setDokumentVorlageName(this.dokumentVorlageName);
      }
                             if (hasChangedErstellungszeitpunkt) {
        other.setErstellungszeitpunkt(this.erstellungszeitpunkt);
      }
             }





    @javax.persistence.Transient
    private transient PersonendatenDateiExportTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public PersonendatenDateiExportTK getPersonendatenDateiExportTK(){
    if (tkCache==null) {
    tkCache = new PersonendatenDateiExportTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getPersonendatenDateiExportTK();
    }

  @Override
  public PersonendatenDateiExportUK getUk(){
    return getPersonendatenDateiExportUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return PersonendatenDateiExport.class;
  }

public PersonendatenDateiExportUK getPersonendatenDateiExportUK(){

   return  new PersonendatenDateiExportUK(



  );
}

  @javax.persistence.Transient
  private transient PersonendatenDateiExportProperties properties;

  public PersonendatenDateiExportProperties getProperties(){
    if (properties == null) {
      properties = new PersonendatenDateiExportProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public PersonendatenDateiExportProperties getPersonendatenDateiExportProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return PersonendatenDateiExportConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                                         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                                                            return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "PERSONENDATEN_DATEI_EXPORT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "PersonendatenDateiExport";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonendatenDateiExportConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, PersonendatenDateiExportConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(benutzerkennung, this, PersonendatenDateiExportConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonendatenDateiExportConstants.BENUTZERKENNUNG_MAX_LENGTH , 1 ,  benutzerkennung, this, PersonendatenDateiExportConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(dateiname, this, PersonendatenDateiExportConstants.MESSAGE_KEY_DATEINAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonendatenDateiExportConstants.DATEINAME_MAX_LENGTH , 1 ,  dateiname, this, PersonendatenDateiExportConstants.MESSAGE_KEY_DATEINAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(dateiArt, this, PersonendatenDateiExportConstants.MESSAGE_KEY_DATEI_ART_EINZAHL, validationResult);
                                                                                                                                                                                            de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_DATEINAME_MAX_LENGTH ,  dokumentVorlageDateiname, this, PersonendatenDateiExportConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_DATEINAME_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(PersonendatenDateiExportConstants.DOKUMENT_VORLAGE_NAME_MAX_LENGTH ,  dokumentVorlageName, this, PersonendatenDateiExportConstants.MESSAGE_KEY_DOKUMENT_VORLAGE_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(erstellungszeitpunkt, this, PersonendatenDateiExportConstants.MESSAGE_KEY_ERSTELLUNGSZEITPUNKT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
